clang-tools 10.0.0

Public Member Functions | List of all members
clang::tidy::utils::HeaderGuardCheck Class Referenceabstract

Finds and fixes header guards. More...

`#include <HeaderGuard.h>`

Inheritance diagram for clang::tidy::utils::HeaderGuardCheck:
[legend]
Collaboration diagram for clang::tidy::utils::HeaderGuardCheck:
[legend]

## Public Member Functions
| HeaderGuardCheck (StringRef Name, ClangTidyContext *Context)
void | registerPPCallbacks (const SourceManager &SM, Preprocessor *PP, Preprocessor *ModuleExpanderPP) override
| Override this to register `PPCallbacks` in the preprocessor. More...
virtual bool | shouldSuggestEndifComment (StringRef Filename)
| Returns `true` if the check should suggest inserting a trailing comment on the `#endif` of the header guard. More...
virtual bool | shouldFixHeaderGuard (StringRef Filename)
| Returns `true` if the check should suggest changing an existing header guard to the string returned by `HeaderGuardCheck::getHeaderGuard`. More...
virtual bool | shouldSuggestToAddHeaderGuard (StringRef Filename)
| Returns `true` if the check should add a header guard to the file if it has none. More...
virtual std::string | formatEndIf (StringRef HeaderGuard)
| Returns a replacement for the `#endif` line with a comment mentioning `HeaderGuard`. More...
virtual std::string | getHeaderGuard (StringRef Filename, StringRef OldGuard=StringRef())=0
| Gets the canonical header guard for a file. More...
Public Member Functions inherited from clang::tidy::ClangTidyCheck
| ClangTidyCheck (StringRef CheckName, ClangTidyContext *Context)
| Initializes the check with `CheckName` and `Context`. More...
virtual void | registerMatchers (ast_matchers::MatchFinder *Finder)
| Override this to register AST matchers with `Finder`. More...
virtual void | check (const ast_matchers::MatchFinder::MatchResult &Result)
| `ClangTidyChecks` that register ASTMatchers should do the actual work in here. More...
DiagnosticBuilder | diag (SourceLocation Loc, StringRef Description, DiagnosticIDs::Level Level=DiagnosticIDs::Warning)
| Add a diagnostic with the check's name. More...
virtual void | storeOptions (ClangTidyOptions::OptionMap &Options)
| Should store all options supported by this check with their current values or default values for options that haven't been overridden. More...

## Additional Inherited Members
Protected Member Functions inherited from clang::tidy::ClangTidyCheck
StringRef | getCurrentMainFile () const
| Returns the main file name of the current translation unit. More...
const LangOptions & | getLangOpts () const
| Returns the language options from the context. More...
Protected Attributes inherited from clang::tidy::ClangTidyCheck
OptionsView | Options

## Detailed Description

Finds and fixes header guards.

The check supports these options:

- `HeaderFileExtensions`: a comma-separated list of filename extensions of header files (The filename extension should not contain "." prefix). ",h,hh,hpp,hxx" by default. For extension-less header files, using an empty string or leaving an empty string between "," if there are other filename extensions.

Definition at line 26 of file HeaderGuard.h.

## Constructor & Destructor Documentation

## ◆ HeaderGuardCheck()

clang::tidy::utils::HeaderGuardCheck::HeaderGuardCheck | ( | StringRef | Name,
|  | ClangTidyContext * | Context
| ) |  |
| inline

Definition at line 28 of file HeaderGuard.h.

References clang::tidy::utils::parseHeaderFileExtensions(), and registerPPCallbacks().

## Member Function Documentation

## ◆ formatEndIf()

std::string clang::tidy::utils::HeaderGuardCheck::formatEndIf | ( | StringRef | HeaderGuard | ) |
| virtual

Returns a replacement for the `#endif` line with a comment mentioning `HeaderGuard`.

The replacement should start with `endif`.

Definition at line 285 of file HeaderGuard.cpp.

## ◆ getHeaderGuard()

virtual std::string clang::tidy::utils::HeaderGuardCheck::getHeaderGuard | ( | StringRef | Filename,
|  | StringRef | OldGuard = `StringRef()`
| ) |  |
| pure virtual

Gets the canonical header guard for a file.

Implemented in clang::tidy::llvm_check::LLVMHeaderGuardCheck.

## ◆ registerPPCallbacks()

void clang::tidy::utils::HeaderGuardCheck::registerPPCallbacks | ( | const SourceManager & | SM,
|  | Preprocessor * | PP,
|  | Preprocessor * | ModuleExpanderPP
| ) |  |
| override virtual

Override this to register `PPCallbacks` in the preprocessor.

This should be used for clang-tidy checks that analyze preprocessor- dependent properties, e.g. include directives and macro definitions.

There are two Preprocessors to choose from that differ in how they handle modular #includes:

- PP is the real Preprocessor. It doesn't walk into modular #includes and thus doesn't generate PPCallbacks for their contents.
- ModuleExpanderPP preprocesses the whole translation unit in the non-modular mode, which allows it to generate PPCallbacks not only for the main file and textual headers, but also for all transitively included modular headers when the analysis runs with modules enabled. When modules are not enabled ModuleExpanderPP just points to the real preprocessor.

Reimplemented from clang::tidy::ClangTidyCheck.

Definition at line 269 of file HeaderGuard.cpp.

Referenced by HeaderGuardCheck().

## ◆ shouldFixHeaderGuard()

bool clang::tidy::utils::HeaderGuardCheck::shouldFixHeaderGuard | ( | StringRef | Filename | ) |
| virtual

Returns `true` if the check should suggest changing an existing header guard to the string returned by `HeaderGuardCheck::getHeaderGuard`.

Definition at line 279 of file HeaderGuard.cpp.

## ◆ shouldSuggestEndifComment()

bool clang::tidy::utils::HeaderGuardCheck::shouldSuggestEndifComment | ( | StringRef | Filename | ) |
| virtual

Returns `true` if the check should suggest inserting a trailing comment on the `#endif` of the header guard.

It will use the same name as returned by `HeaderGuardCheck::getHeaderGuard`.

Reimplemented in clang::tidy::llvm_check::LLVMHeaderGuardCheck.

Definition at line 275 of file HeaderGuard.cpp.

References clang::tidy::utils::isHeaderFileExtension().

## ◆ shouldSuggestToAddHeaderGuard()

bool clang::tidy::utils::HeaderGuardCheck::shouldSuggestToAddHeaderGuard | ( | StringRef | Filename | ) |
| virtual

Returns `true` if the check should add a header guard to the file if it has none.

Definition at line 281 of file HeaderGuard.cpp.

References clang::tidy::utils::isHeaderFileExtension().

The documentation for this class was generated from the following files:

- HeaderGuard.h
- HeaderGuard.cpp